/*****************************************************************************
*
* Atmel Corporation
*
* File              : main.c
* Compiler          : IAR EWAAVR 2.28a/3.10c
* Revision          : $Revision: 2.0 $
* Date              : $Date: Wednesday, February 15, 2006 09:52:02 UTC $
* Updated by        : $Author: raapeland $
*
* Support mail      : avr@atmel.com
*
* Supported devices : All devices with Bootloader Capabilities 
*                     , and at least 1-KB SRAM can be used.
*                     The example is written for  ATmega8
*                                                 ATmega16
*                                                 ATmega162
*                                                 ATmega169
*                                                 ATmega32
*                                                 ATmega64
*                                                 ATmega128
*
* AppNote           : AVR231 - AES Bootloader
*
****************************************************************************/

//=============================================================================
// Polynome used in CRC calculations

#define	CRC_POLYNOME 0x8005

//=============================================================================
.global	CRC
.func CRC

//=============================================================================
// CRC calculation routine

//Parameter aus C kommen in 24(Low)/25(High) und 22

CRC:
	ldi		r20, 0x08 //Scheint die Anzahl der Bits zu sein
	ldi		r18, 0x05 //Low Polynome
	ldi		r19, 0x80 //High Polynome

CRC_Loop:
	; Rotate left. If MSb is 1 -> divide with Generator-polynome.
	lsl		r22 //Parameter 2
	rol		r24 //Parameter 1 Low
	rol		r25 //Parameter 1 High
	brcc	CRC_SkipEor

	eor		r24, r18
	eor		r25, r19

CRC_SkipEor:
	dec		r20
	brne	CRC_Loop
	ret

//=============================================================================

.endfunc
